"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FeedbackModalInternal = void 0;
const react_1 = __importStar(require("react"));
const react_core_1 = require("@patternfly/react-core");
const react_icons_1 = require("@patternfly/react-icons");
const pf_feedback_svg_1 = __importDefault(require("../images/pf_feedback.svg"));
const FeedbackForm_1 = require("./FeedbackForm");
const FeedbackSuccess_1 = __importDefault(require("./FeedbackSuccess"));
const FeedbackError_1 = __importDefault(require("./FeedbackError"));
require("./Feedback.css");
const LocaleContext_1 = require("../context/LocaleContext");
exports.FeedbackModalInternal = (0, react_1.memo)(({ email, isOpen, onShareFeedback, onJoinMailingList, onReportABug, onOpenSupportCase, onClose, feedbackImg }) => {
    const intl = react_1.default.useContext(LocaleContext_1.LocaleContext);
    const emailRef = (0, react_1.useRef)(email ? email : '');
    const [modalPage, setModalPage] = (0, react_1.useState)('feedbackHome');
    const handleCloseModal = () => {
        if (onClose) {
            onClose();
        }
        setModalPage("feedbackHome");
    };
    const updateEmail = (email) => { if (emailRef.current !== email && email !== '') {
        emailRef.current = email;
    } };
    const onSubmit = (feedbackPage, results) => {
        if (results instanceof Promise) {
            results.then((results) => {
                results === false ? setModalPage("feedbackError") : setModalPage(feedbackPage);
            });
        }
        else {
            results === false ? setModalPage("feedbackError") : setModalPage(feedbackPage);
        }
    };
    const ModalDescription = ({ modalPage }) => {
        switch (modalPage) {
            case 'feedbackHome':
                return (react_1.default.createElement("div", { className: "chr-c-feedback-content" },
                    react_1.default.createElement(react_core_1.TextContent, null,
                        react_1.default.createElement(react_core_1.Text, { component: react_core_1.TextVariants.h1 }, intl.tellAboutExperience),
                        react_1.default.createElement(react_core_1.Text, null, intl.helpUsImproveHCC)),
                    react_1.default.createElement("div", { className: "chr-c-feedback-cards" },
                        react_1.default.createElement(react_core_1.Card, { isSelectableRaised: true, isCompact: true, onClick: () => { typeof onShareFeedback === 'string' ? window.open(onShareFeedback, '_blank') : setModalPage('feedbackOne'); } },
                            react_1.default.createElement(react_core_1.CardTitle, { className: "chr-c-feedback-card-title" },
                                intl.shareFeedback,
                                " ",
                                typeof onShareFeedback === 'string' ? react_1.default.createElement(react_icons_1.ExternalLinkAltIcon, null) : null),
                            react_1.default.createElement(react_core_1.CardBody, null,
                                intl.howIsConsoleExperience,
                                " ")),
                        react_1.default.createElement("br", null),
                        onReportABug ?
                            react_1.default.createElement(react_1.default.Fragment, null,
                                react_1.default.createElement(react_core_1.Card, { isSelectableRaised: true, isCompact: true, onClick: () => { typeof onReportABug === 'string' ? window.open(onReportABug, '_blank') : setModalPage('reportBugOne'); } },
                                    react_1.default.createElement(react_core_1.CardTitle, { className: "chr-c-feedback-card-title" },
                                        intl.reportABug,
                                        " ",
                                        typeof onReportABug === 'string' ? react_1.default.createElement(react_icons_1.ExternalLinkAltIcon, null) : null,
                                        " "),
                                    react_1.default.createElement(react_core_1.CardBody, null, intl.describeBugUrgentCases)),
                                react_1.default.createElement("br", null)) : null,
                        onOpenSupportCase ? react_1.default.createElement(react_core_1.Card, { isSelectableRaised: true, isCompact: true, onClick: () => {
                                window.open(onOpenSupportCase, '_blank');
                            } },
                            react_1.default.createElement(react_core_1.CardTitle, { className: "chr-c-feedback-card-title" },
                                react_1.default.createElement(react_core_1.Text, null,
                                    intl.openSupportCase,
                                    " ",
                                    react_1.default.createElement(react_icons_1.ExternalLinkAltIcon, null))),
                            react_1.default.createElement(react_core_1.CardBody, null, intl.getSupport)) : null,
                        react_1.default.createElement("br", null),
                        onJoinMailingList ?
                            react_1.default.createElement(react_core_1.Card, { isSelectableRaised: true, isCompact: true, onClick: () => { typeof onJoinMailingList === 'string' ? window.open(onJoinMailingList, '_blank') : setModalPage('informDirection'); } },
                                react_1.default.createElement(react_core_1.CardTitle, { className: "chr-c-feedback-card-title" },
                                    react_1.default.createElement(react_core_1.Text, null,
                                        intl.informDirection,
                                        " ",
                                        typeof onJoinMailingList === 'string' ? react_1.default.createElement(react_icons_1.ExternalLinkAltIcon, null) : null)),
                                react_1.default.createElement(react_core_1.CardBody, null, intl.learnAboutResearchOpportunities)) : null),
                    react_1.default.createElement(react_core_1.Button, { className: "chr-c-feedback-button", ouiaId: "cancel-feedback", key: "cancel", variant: "link", onClick: handleCloseModal }, intl.cancel)));
            case 'feedbackOne':
                return (react_1.default.createElement(FeedbackForm_1.FeedbackForm, { email: emailRef.current, onCloseModal: handleCloseModal, onSubmit: (email, textAreaValue) => {
                        let results = true;
                        if (onShareFeedback && typeof onShareFeedback === 'function') {
                            results = onShareFeedback(email, textAreaValue);
                            updateEmail(email);
                        }
                        onSubmit('feedbackSuccess', results);
                    }, onClickBack: () => setModalPage('feedbackHome'), handleFeedbackError: () => setModalPage('feedbackError'), modalTitle: intl.shareYourFeedback, textareaLabel: intl.enterFeedback, feedbackType: "Feedback", checkboxDescription: intl.learnAboutResearchOpportunities, submitTitle: intl.submitFeedback }));
            case 'reportBugOne':
                return (react_1.default.createElement(FeedbackForm_1.FeedbackForm, { email: emailRef.current, onCloseModal: handleCloseModal, onSubmit: (email, textAreaValue) => {
                        let results = true;
                        if (onReportABug && typeof onReportABug === 'function') {
                            results = onReportABug(email, textAreaValue);
                            updateEmail(email);
                        }
                        onSubmit('bugReportSuccess', results);
                    }, onClickBack: () => setModalPage('feedbackHome'), handleFeedbackError: () => setModalPage('feedbackError'), modalTitle: intl.reportABug, modalDescription: react_1.default.createElement(react_core_1.Text, null,
                        intl.describeReportBug,
                        ' ',
                        react_1.default.createElement(react_core_1.Text, { component: "a", href: "https://access.redhat.com/support/cases/#/case/new/open-case?caseCreate=true", target: "_blank" },
                            intl.openSupportCase,
                            " ",
                            react_1.default.createElement(react_icons_1.ExternalLinkAltIcon, null))), feedbackType: "Bug", checkboxDescription: `${intl.learnAboutResearchOpportunities} ${intl.weNeverSharePersonalInformation}`, submitTitle: intl.submitFeedback }));
            case 'informDirection':
                return (react_1.default.createElement(FeedbackForm_1.FeedbackForm, { email: emailRef.current, onCloseModal: handleCloseModal, onSubmit: (email, _textAreaValue) => {
                        let results = true;
                        if (onJoinMailingList && typeof onJoinMailingList === 'function') {
                            results = onJoinMailingList(email);
                            updateEmail(email);
                        }
                        onSubmit('informDirectionSuccess', results);
                    }, onClickBack: () => setModalPage('feedbackHome'), handleFeedbackError: () => setModalPage('feedbackError'), modalTitle: intl.informDirection, modalDescription: react_1.default.createElement(react_core_1.Text, null,
                        intl.informDirectionDescription,
                        react_1.default.createElement(react_core_1.Text, { component: "a", href: "https://www.redhat.com/en/about/user-research", target: "_blank" }, intl.userResearchTeam),
                        intl.directInfluence), feedbackType: "[Research Opportunities]", textAreaHidden: true, checkboxDescription: intl.weNeverSharePersonalInformation, submitTitle: intl.joinMailingList }));
            case 'feedbackSuccess':
                return (react_1.default.createElement(FeedbackSuccess_1.default, { successTitle: intl.feedbackSent, successDescription: intl.thankYouForFeedback, onCloseModal: handleCloseModal }));
            case 'bugReportSuccess':
                return (react_1.default.createElement(FeedbackSuccess_1.default, { successTitle: intl.bugReported, successDescription: intl.teamWillReviewBug, onCloseModal: handleCloseModal }));
            case 'informDirectionSuccess':
                return (react_1.default.createElement(FeedbackSuccess_1.default, { successTitle: intl.responseSent, successDescription: intl.thankYouForInterest, onCloseModal: handleCloseModal }));
            case 'feedbackError':
                return react_1.default.createElement(FeedbackError_1.default, { onCloseModal: handleCloseModal });
        }
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_core_1.Modal, { "aria-label": "Feedback modal", isOpen: isOpen, className: "chr-c-feedback-modal", variant: react_core_1.ModalVariant.large, onClose: handleCloseModal },
            react_1.default.createElement(react_core_1.Grid, null,
                react_1.default.createElement(react_core_1.GridItem, { span: 8, rowSpan: 12 },
                    react_1.default.createElement(ModalDescription, { modalPage: modalPage })),
                react_1.default.createElement(react_core_1.GridItem, { span: 4, className: "chr-c-feedback-image" },
                    react_1.default.createElement("img", { alt: "feedback illustration", src: feedbackImg ? feedbackImg : pf_feedback_svg_1.default }))))));
});
exports.FeedbackModalInternal.displayName = 'FeedbackModal';
exports.default = exports.FeedbackModalInternal;
