"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_core_1 = require("@patternfly/react-core");
const check_icon_1 = __importDefault(require("@patternfly/react-icons/dist/js/icons/check-icon"));
require("./Feedback.css");
const LocaleContext_1 = require("../context/LocaleContext");
const FeedbackSuccess = ({ onCloseModal, successTitle, successDescription }) => {
    const intl = react_1.default.useContext(LocaleContext_1.LocaleContext);
    return (react_1.default.createElement("div", { className: "chr-c-feedback-success-content" },
        react_1.default.createElement(check_icon_1.default, { size: "md", color: "var(--pf-global--success-color--100)", className: "pf-u-mx-auto" }),
        react_1.default.createElement(react_core_1.TextContent, null,
            react_1.default.createElement(react_core_1.Text, { component: react_core_1.TextVariants.h1 }, successTitle),
            react_1.default.createElement(react_core_1.Text, null, successDescription)),
        react_1.default.createElement(react_core_1.Button, { variant: "primary", onClick: onCloseModal }, intl.close)));
};
exports.default = FeedbackSuccess;
